; Fichier include SCASM  pour POLY3D TYPE = &PYLONE2
; Include SCASM FILE  for POLY3D TYPE = &PYLONE2

; auteur : michel manelphe

; pylone avec transformateur

; couleur 1 = cots
; couleur 2 = partie centrale
; couleur 3 = 0
; The following line is required by TerraBuilder:
; Macro(  C:\APT210\API\PYLONE2.API  NN  EE   AreaRange  scale  heading  user1  user2  user3  user4  range elev  detail  V2  V2Val )

; standard size / scale 1.00: length  :  3  m
;                             width   : 10  m
;                             height  : 28  m



Area(  b %1 %2 %3 )

mif( %12  )
IfVarRange(  :  0346  %12  4  ) 
mifend


        PerspectiveCall( :D0  )
        ;ShadowCall( :D1  )
        Jump( :fin  )

:D0
        Perspective

:D1
        
    mif( %11  )
        RefPoint(  2  :D3  %4 %1 %2 v1= %10 E= %11 %13 %14 )
    melse
        RefPoint(  7  :D3  %4 %1 %2 v1= %10 %13 %14 )
    mifend

        RotatedCall(  :D2  0 0 %5  )
        Return

:D2
        Points(  0     ;pylone
         0       4       0      ;0
        -2       4       0      ;1    
        -2       4      -2      ;2
         0       4      -2      ;3
         0       8       0      ;4
        -2       8       0      ;5    
        -2       8      -2      ;6
         0       8      -2      ;7
         0       12       0      ;8
        -2       12       0      ;9    
        -2       12      -2      ;10
         0       12      -2      ;11
         0      16       0      ;12
        -2      16       0      ;13    
        -2      16      -2      ;14
         0      16      -2      ;15
         0      20       0      ;16
        -2      20       0      ;17    
        -2      20      -2      ;18
         0      20      -2      ;19
         0      24       0      ;20
        -2      24       0      ;21    
        -2      24      -2      ;22
         0      24      -2      ;23
         0      28       0      ;24
        -2      28       0      ;25    
        -2      28      -2      ;26
         0      28      -2      ;27
         )

        Call( :antenne )
        Call( :rampe )
        Return
        
:antenne        
        LineColor(  04 f0  )
        MoveToPt(  0  )
        DrawToPt(  4 2 6 0  )
        MoveToPt(  1  )
        DrawToPt(  5 3 7 1  )

        LineColor(  05 f0  )
        MoveToPt(  4  )
        DrawToPt(  8 6 10 4  )
        MoveToPt(  5  )
        DrawToPt(  9 7 11 5  )

        LineColor(  04 f0  )
        MoveToPt(  8  )
        DrawToPt(  12 10 14 8  )
        MoveToPt(  9  )
        DrawToPt(  13 11 15 9  )

        LineColor(  05 f0  )
        MoveToPt(  12  )
        DrawToPt(  16 14 18 12  ) 
        MoveToPt(  13  )
        DrawToPt(  17 15 19 13  )

        LineColor(  04 f0  )
        MoveToPt(  16 )  
        DrawToPt(  20 18 22 16  )
        MoveToPt(  17  )
        DrawToPt(  21 19 23 17  )

        LineColor(  05 f0  )
        MoveToPt(  20  )
        DrawToPt(  24 22 26 20 )
        MoveToPt(  21  )
        DrawToPt(  25 23 27 21  )
        MoveToPt(  24  )
        DrawToPt(  25 26 27 24  )


:rampe
        ;rampe suprieure clignotante claire la nuit
        IfVarAnd( :D3  028C  0006 )
        IfVarAnd( :clignot 282 3 )
        LineColor(  0F F0  )
        Jump( :eclaire )
        
:clignot        
        IfVarAnd( :D3  282 300 )        
        LineColor(  0F F0  )

:eclaire
        LineColor(  0F F0  )
        Dot(         0      28       0   )   ;24
        Dot(        -2      28       0   )   ;25    
        Dot(        -2      28      -2   )   ;26
        Dot(         0      28      -2   )   ;27
        
:D3
        Return

:fin
EndA


Area(  b %1 %2 %3 )
        PerspectiveCall( :D0  )
        ;ShadowCall( :D1  )
        Jump( :fin )

:D0
        Perspective

:D1
    mif( %11  )
        RefPoint(  2  :D3  %4 %1 %2 v1= %10 E= %11 %13 %14 )
    melse
        RefPoint(  7  :D3  %4 %1 %2 v1= %10 %13 %14 )
    mifend
        RotatedCall(  :D2  0 0 %5  )
        Return

:D2
        Points( 0     ;transformateur
        0         0       -3      ;0
       -3         0       -3      ;1
       -3         4       -3      ;2
        0         4       -3      ;3
        0         0       0       ;4
       -3         0       0       ;5
       -3         4       0       ;6
        0         4       0       ;7
        0         0       3       ;8
       -3         0       3       ;9
       -3         4       3       ;10
        0         4       3       ;11
        0         0       6       ;12     
       -3         0       6       ;13
       -3         4       6       ;14
        0         4       6       ;15
        )
        

        SurfaceColor(  %6 f0  )
        Poly(  a  0  1  2  3  )
        Poly(  a  4  0  3  7  )
        Poly(  a  6 2 1 5  )
        Poly(  a  7  3  2  6  )

        SurfaceColor(  %7 f0  )
        Poly(  a  8  4  7  11  )
        Poly(  a  10 6 5 9  )
        Poly(  a  11  7  6  10  )

        SurfaceColor(  %6 f0  )
        Poly(  a  15 14 13 12  )
        Poly(  a  12  8  11  15  )
        Poly(  a  14 10 9 13  )
        Poly(  a  15  11  10  14  )

        Return

:D3
        Return

:fin
EndA

